''********************************
''*  16Colour Paint Application  *
''********************************
'' made by Andy Schenk  (version 0.1)
'' based on the 16colour driver by 
'' (C) 2009 Jim Bagley

CON

{Hybrid Setup
_clkmode = xtal1 + pll16x
_xinfreq = 6_000_000
modepins = %011_0000
'}
'{Proto/Demo Board Setup
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  modepins = %001_0101
'}
{Hydra Setup
_clkmode = xtal1 + pll8x
_xinfreq = 10_000_000
modepins = %011_0000
'}

 PAL=%0001
 NTSC=%0000
 INTERLACED=%0010

 x_tiles = 8  '*8fat=128
 y_tiles = 7  '*16=112
 menY    = y_tiles*16-16

 x_pixels = x_tiles*16
 y_pixels = y_tiles*16
 bsize = x_tiles*(y_tiles-1)*128

' ---- custmize ----
 MODE    =  PAL + $40   'or NTSC + $40
' SD_BPIN = 8
' ------------------
 my_hx = 22+((mode&1)<<2)
  
OBJ
  tv    : "JB_TV_AMS_02"
  ms    : "mouse"
  pc    : "pc_text"

VAR
  long  color, oldc, cmd, zoom
  long  msx, msy, msbut, oldx, oldy, oldb
  long  curx, cury, curc
  long  sp, sx,sy,sw,sh
  long  pcm,pct,pcb,pcl,pcr

  byte  buff[bsize]
  byte  stack[256]

PUB Main | i,c,x,y

  pc.start(12)
  ms.start(24,25)
  tv.start(@tvparams)
  ms.bound_scales(6,6,1)
  ms.bound_limits(0,0,2,x_pixels,y_pixels,255)
  color := 1
  cmd := 1
  
  showMenu
  repeat
    mouse_evt
    if zoom==0
      if msbut==0 and msy<menY  'button release
        case cmd
          5: longmove(@data,@buff,bsize>>2)
             if msy < menY-20
               obox(msx,msy,32,20,0)
               VSync
               obox(msx,msy,32,20,1)
               VSync
          10: longmove(@data,@buff,bsize>>2)

      if msbut==1 and msy<menY  'draw
        case cmd
          1..3: plot(msx,msy,color)
          8:    fill4(msx,msy,color)
          5:    sx := msx
                sy := msy
                sw := x_pixels>>2
                sh := y_pixels>>2-5
                zoomIn
                msbut := 0
          11:   repeat i from 0 to sh  'copy
                  bytemove(@data+msx>>1+(msy+i)<<6,@buff+sx>>1+(sy+i)<<6,sw>>1)
        curx := msx
        cury := msy
      if msbut==2 and msy<menY  'right button
        case cmd
          1:  plot(msx,msy,0)
          2:  lineto(msx,msy,color)
          3:  obox(curx,cury,msx-curx,msy-cury,color)
          4:  x := (msx-curx)/2
              y := (msy-cury)/2
              ellips(curx+x,cury+y,x,y,color)
          10: longmove(@data,@buff,bsize>>2)
              sx := curx
              sy := cury
              sw := msx-curx
              sh := msy-cury
              obox(curx,cury,sw,sh,0)
              VSync
              obox(curx,cury,sw,sh,1)
              VSync

    if zoom==1
      if msbut>0 and msy<menY  'draw/erase
        if msbut==1
          c := color
        else
          c := 0
        case cmd
          5:  plotb(msx>>2+sx,msy>>2+sy,c)
              y := msy & $FC
              repeat x from msx&$FC to (msx&$FC)+2
                plot(x,y+0,c)
                plot(x,y+1,c)
                plot(x,y+2,c)
       
    if msbut>0 and msy>menY  'menu
      if msx < 55
        color := msx/6 + msy&8
      elseif msbut==1
        oldc := cmd
        cmd := (msx-60)/10 + (msy&8)
        case cmd
          0:  longmove(@buff,@data,bsize>>2) 'cls
              bytefill(@data,0,bsize)
          9:  longmove(@data,@buff,bsize>>2) 'undo
              cmd := oldc
          12: savePic
      elseif msbut==2
        oldc := cmd
        cmd := (msx-60)/10 + (msy&8)
        case cmd
          0: longmove(@buff,@data,bsize>>2)
             longfill(@data,$06,bsize>>2)   'cls grid
             repeat i from 0 to 78 step 8
               plot(2,i,6)
               plot(127,i,6)
          
      if zoom
        if cmd<>5
          longmove(@data,@buff,bsize>>2)
          zoom := 0
      else
        if cmd>0
          longmove(@buff,@data,bsize>>2)
        else
          cmd := oldc
          
      showMenu

PRI mouse_evt
 pcm := point(oldx,oldy)
 pct := point(oldx,oldy-1)
 pcb := point(oldx,oldy+1)
 pcl := point(oldx-1,oldy)
 pcr := point(oldx+1,oldy)
 repeat
   plot(oldx,oldy,0)
   plot(oldx,oldy-1,1)
   plot(oldx,oldy+1,1)
   plot(oldx-1,oldy,1)
   plot(oldx+1,oldy,1)
   curc ^= 1
   msx := ms.bound_x
   msy := y_pixels-ms.bound_y
   msbut := ms.buttons
   if msbut<>oldb or msx<>oldx or msy<>oldy
     quit
 plot(oldx,oldy,pcm)
 plot(oldx,oldy-1,pct)
 plot(oldx,oldy+1,pcb)
 plot(oldx-1,oldy,pcl)
 plot(oldx+1,oldy,pcr)
 oldx := msx
 oldy := msy
 oldb := msbut

PUB showMenu | i,x,y
  bytefill(@data+menY<<6,$DD,16<<6)  'clear
  bytefill(@data+(menY+1)<<6,0,15<<6)
  repeat x from 0 to 7*6 step 6    'color boxes
    repeat y from 1 to 6
      repeat i from 1 to 5
        plot(x+i,y+menY,x/6)
    repeat y from 1 to 6
      repeat i from 1 to 5
        plot(x+i,y+menY+8,x/6+8)
  obox((color&7)*6,color&8+menY,6,7,1) 'selected

  print(string(96,97),60,menY)     'menu
  print(string("bc"),70,menY)
  print(string("de"),80,menY)
  print(string("fg"),90,menY)
  print(string("hi"),100,menY)
  print(string("jk"),110,menY)

  print(string("lm"),60,menY+8)
  print(string("no"),70,menY+8)
  print(string("pq"),80,menY+8)
  print(string("rs"),90,menY+8)
  print(string("tu"),100,menY+8)
  print(string("vw"),110,menY+8)
  obox((cmd&7)*10+59,cmd&8+menY,7,7,$D) 'selected
  
PUB at(x,y)
  curx := x
  cury := y

PUB plot(x,y,c)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return
  c&=15
  if(x&1)
    data[y<<6+x>>1]:=(data[y<<6+x>>1]&$f0)+c
  else
    data[y<<6+x>>1]:=(data[y<<6+x>>1]&$0f)+(c<<4)

PUB point(x,y)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return 0
  if x&1
    return data[y<<6+x>>1] & $0F
  else                                                                                                  
    return data[y<<6+x>>1] >> 4                                                                         

PUB lineto(x,y,c) | n,w,h
  w := x-curx
  h := y-cury
  if ||w > ||h
    repeat n from 0 to w
      plot(curx+n, cury+(h*n)/w, c)
  else
    repeat n from 0 to h
      plot(curx+(w*n)/h, cury+n, c)
  curx := x
  cury := y

PUB obox(x,y,w,h,c)
  at(x,y)
  lineto(x+w,y,c)
  lineto(x+w,y+h,c)
  lineto(x,y+h,c)
  lineto(x,y,c)

PUB fill4(x,y,c) | oc
  oc := point(x,y)
  push(x,y)
  repeat while sp>0
    y := stack[--sp]
    x := stack[--sp]
    if point(x,y) == oc and x=>0 and x<x_pixels and y=>0 and y<menY and oc<>c
      plot(x,y,c)
      push(x,y+1)
      push(x,y-1)
      push(x+1,y)
      push(x-1,y)

PRI push(a,b)
  if sp < 254
    stack[sp++] := a
    stack[sp++] := b

PUB ellips(x,y,rx,ry,c)  | d,si,co
  repeat d from 0 to 360 step 2
    si := sin(d,ry)
    co := sin(d+90,rx)
    plot(x+co,y+si,c)
    
PRI sin(degree,radius) | a,q
  a := degree * 91 / 4
  q := a & $1000
  if a & $800
    a := -a
  a := word[($E000>>1|a)<<1]
  if q
    a := -a
  return (a*radius)~>16
    
PUB print(s,x,y)        's=string
  repeat while byte[s][0]
    prtchar(byte[s][0],x,y)
    if byte[s][0] < 96
      x++
    s++
    x+=3

PUB prtchar(ch,x,y)  | f,b,c
  f := (ch-32)*3
  repeat b from 1 to 7
    plot(x,y+b,font3x7[f]>>b&1)
    plot(x+1,y+b,font3x7[f+1]>>b&1)
    plot(x+2,y+b,font3x7[f+2]>>b&1)
    
PUB VSync
  repeat until VSyncFlag<>1
  repeat until VSyncFlag==1

PUB zoomIn | x,y,i
  zoom := 1
  longmove(@data,@buff,bsize>>2)
  repeat x from sw to 0
    repeat y from sh to 0
      repeat i from 2 to 0
        plot(x<<2+0,y<<2+i,pointb(sx+x,sy+y))
        plot(x<<2+1,y<<2+i,pointb(sx+x,sy+y))
        plot(x<<2+2,y<<2+i,pointb(sx+x,sy+y))
        plot(x<<2+3,y<<2+i,0)
      repeat i from 0 to 3
        plot(x<<2+i,y<<2+3,0)

PUB plotb(x,y,c)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return
  c&=15
  if(x&1)
    buff[y<<6+x>>1]:=(buff[y<<6+x>>1]&$f0)+c
  else
    buff[y<<6+x>>1]:=(buff[y<<6+x>>1]&$0f)+(c<<4)

PUB pointb(x,y)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return 0
  if x&1
    return buff[y<<6+x>>1] & $0F
  else                                                                                                  
    return buff[y<<6+x>>1] >> 4                                                                         

PUB savePic | x,y,w,h
  if zoom==0
    longmove(@buff,@data,bsize>>2)
    w := x_pixels>>1 - 1
    h := y_pixels - 17
  else
    w := x_pixels>>3 - 1
    h := y_pixels>>2 - 1
  bytefill(@data,0,bsize)
  print(string("SAVE TO PROP-TERMINAL..."),0,0)
  pc.out(0)
  repeat y from 0 to h    'send to PropTerminal
    waitcnt(clkfreq>>4 + cnt)
    repeat x from 0 to w
      if x&15 == 0
        if y==0 and x==0
          pc.str(string(13,"data  byte "))
        else
          pc.str(string(13,"      byte "))
      else
        pc.out(",")
      pc.out("$")
      pc.hex(buff[y<<6+x],2)
  print(string("...DONE"),0,10)
  print(string("USE COPY TEXT IN TERMINAL"),0,20)
  print(string("THEN PASTE INTO SOURCE"),0,30)
  print(string("PRESS RIGHT MOUSEBUTTON"),0,45)
  repeat until ms.buttons==2
  longmove(@data,@buff,bsize>>2)
      
         
DAT

tvparams  long 0           'status
          long 1           'enable
          long modepins    'pins
          long mode        'mode
          long x_tiles     'hc
          long y_tiles     'vc
          long my_hx       'hx
VSyncFlag long 0
nextline  long 0                        
disp_ptr  long @data+$10
bordercol long $02
          long @palette+$10

' ----- Picture -----
  long  
palette   byte $02,$07,$28,$8d,$ba,$1a,$db,$3d
          byte $8f,$5f,$3f,$5b,$d8,$04,$CD,$1D

'data      byte 0[bsize]

data  byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$22,$22,$22,$20,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$02,$29,$99,$99,$22,$20,$00,$00,$00
      byte $00,$00,$AA,$A0,$00,$00,$00,$00,$00,$00,$0C,$C0,$00,$00,$08,$88
      byte $88,$00,$00,$00,$00,$88,$88,$88,$00,$00,$00,$00,$00,$00,$03,$33
      byte $30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$02,$99,$99,$99,$99,$22,$00,$00,$00
      byte $00,$0A,$A2,$2A,$A0,$00,$00,$00,$00,$00,$CC,$C0,$00,$00,$08,$CC
      byte $CC,$88,$00,$00,$08,$8C,$CC,$C8,$00,$00,$33,$33,$33,$33,$33,$AA
      byte $33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$99,$99,$92,$00,$00,$00
      byte $00,$AA,$22,$22,$AA,$00,$00,$00,$00,$0C,$C8,$8C,$00,$00,$08,$CC
      byte $CC,$C8,$80,$00,$08,$CC,$CC,$C8,$00,$03,$3A,$AA,$AA,$AA,$AA,$AA
      byte $A3,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$99,$99,$92,$00,$00,$00
      byte $0A,$A2,$22,$22,$2A,$00,$00,$00,$00,$0C,$88,$8C,$00,$00,$08,$CC
      byte $CC,$CC,$80,$00,$08,$CC,$CC,$C8,$00,$03,$AA,$AA,$AA,$AA,$AA,$AA
      byte $AA,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$92,$29,$99,$99,$20,$00,$00
      byte $0A,$22,$22,$22,$2A,$A0,$00,$00,$00,$CC,$88,$8C,$00,$00,$08,$CC
      byte $CC,$CC,$88,$00,$08,$CC,$CC,$C8,$00,$03,$AA,$AA,$AA,$AA,$AA,$AA
      byte $AA,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$22,$22,$29,$99,$20,$00,$00
      byte $AA,$22,$22,$22,$22,$A0,$00,$00,$00,$C8,$88,$8C,$C0,$00,$08,$CC
      byte $CC,$CC,$C8,$00,$08,$CC,$CC,$C8,$00,$03,$AA,$AA,$AA,$AA,$AA,$AA
      byte $AA,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$20,$00,$29,$99,$22,$00,$00
      byte $A2,$22,$2A,$A2,$22,$A0,$00,$00,$00,$C8,$88,$88,$C0,$00,$08,$CC
      byte $CC,$CC,$C8,$80,$08,$CC,$CC,$C8,$00,$03,$AA,$AA,$AA,$AA,$AA,$AA
      byte $A3,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$20,$00,$29,$99,$92,$00,$0A
      byte $A2,$22,$2A,$AA,$22,$A0,$00,$00,$00,$C8,$88,$88,$C0,$00,$08,$CC
      byte $CC,$CC,$CC,$80,$08,$CC,$CC,$C8,$00,$03,$AA,$AA,$AA,$AA,$AA,$AA
      byte $33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$22,$00,$29,$99,$92,$00,$0A
      byte $22,$22,$2A,$0A,$22,$AA,$00,$00,$00,$C8,$88,$88,$C0,$00,$08,$CC
      byte $CC,$CC,$CC,$C8,$08,$CC,$CC,$C8,$00,$03,$3A,$AA,$AA,$AA,$A3,$33
      byte $30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$92,$00,$29,$99,$92,$00,$0A
      byte $22,$22,$AA,$0A,$22,$2A,$00,$00,$0C,$C8,$88,$88,$C0,$00,$08,$CC
      byte $CC,$CC,$CC,$C8,$08,$CC,$CC,$C8,$00,$00,$33,$33,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$92,$22,$29,$99,$92,$00,$AA
      byte $22,$22,$A0,$0A,$A2,$2A,$00,$00,$0C,$88,$88,$88,$C0,$00,$08,$CC
      byte $CC,$CC,$CC,$CC,$88,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$99,$99,$99,$22,$00,$A2
      byte $22,$22,$A0,$00,$A2,$22,$A0,$00,$0C,$88,$88,$88,$C0,$00,$08,$CC
      byte $CC,$CC,$CC,$CC,$88,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$99,$99,$92,$20,$00,$A2
      byte $22,$22,$A0,$00,$A2,$22,$A0,$00,$0C,$88,$88,$88,$C0,$00,$08,$CC
      byte $CC,$CC,$CC,$CC,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$99,$99,$20,$00,$0A,$A2
      byte $22,$22,$A0,$00,$AA,$22,$AA,$00,$0C,$88,$88,$88,$C0,$00,$08,$CC
      byte $CC,$CC,$CC,$CC,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$92,$22,$00,$00,$0A,$22
      byte $22,$22,$AA,$AA,$AA,$22,$2A,$00,$0C,$88,$88,$88,$C0,$00,$08,$CC
      byte $CC,$C8,$CC,$CC,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$20,$00,$00,$00,$0A,$22
      byte $22,$22,$22,$22,$22,$22,$2A,$00,$0C,$88,$88,$88,$C0,$00,$08,$CC
      byte $CC,$C8,$CC,$CC,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$20,$00,$00,$00,$0A,$22
      byte $22,$22,$22,$22,$22,$22,$2A,$00,$0C,$88,$88,$88,$C0,$00,$08,$CC
      byte $CC,$C8,$8C,$CC,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$20,$00,$00,$00,$0A,$22
      byte $22,$22,$22,$22,$22,$22,$2A,$A0,$0C,$88,$88,$88,$C0,$00,$88,$CC
      byte $CC,$C8,$8C,$CC,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$20,$00,$00,$00,$0A,$22
      byte $22,$22,$AA,$AA,$A2,$22,$22,$A0,$0C,$88,$88,$88,$C0,$00,$8C,$CC
      byte $CC,$C8,$88,$CC,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$20,$00,$00,$00,$A2,$22
      byte $22,$22,$A0,$00,$A2,$22,$22,$A0,$0C,$88,$88,$88,$C0,$00,$8C,$CC
      byte $CC,$C8,$08,$CC,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$03,$03,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$20,$00,$00,$00,$A2,$22
      byte $22,$22,$A0,$00,$A2,$22,$22,$A0,$0C,$88,$88,$88,$C0,$00,$8C,$CC
      byte $CC,$C8,$08,$8C,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$33,$03,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$20,$00,$00,$00,$A2,$22
      byte $22,$22,$A0,$00,$AA,$22,$22,$A0,$0C,$88,$88,$88,$C0,$00,$8C,$CC
      byte $CC,$C8,$00,$8C,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$33,$33,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$20,$00,$00,$00,$A2,$22
      byte $22,$2A,$00,$00,$0A,$22,$22,$A0,$0C,$88,$88,$88,$C0,$00,$8C,$CC
      byte $CC,$C8,$00,$88,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$33,$33,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$20,$00,$00,$0A,$22,$22
      byte $22,$AA,$00,$00,$0A,$22,$22,$A0,$0C,$88,$88,$88,$C0,$00,$8C,$CC
      byte $CC,$C8,$00,$08,$CC,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$03,$33,$00,$00,$30,$30,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$29,$99,$99,$20,$00,$00,$0A,$A2,$22
      byte $22,$A0,$00,$00,$0A,$A2,$2A,$A0,$0C,$C8,$88,$8C,$C0,$00,$8C,$CC
      byte $CC,$C8,$00,$08,$8C,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$03,$30,$00,$00,$33,$30,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$22,$99,$99,$20,$00,$00,$0A,$A2,$AA
      byte $AA,$00,$00,$00,$00,$AA,$AA,$00,$08,$C8,$88,$8C,$00,$00,$8C,$CC
      byte $CC,$C8,$00,$00,$8C,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$00,$33,$33,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$02,$22,$22,$20,$00,$00,$00,$AA,$AA
      byte $A0,$00,$00,$00,$00,$00,$00,$00,$00,$CC,$C8,$CC,$00,$00,$8C,$CC
      byte $88,$88,$00,$00,$08,$CC,$CC,$C8,$00,$00,$00,$03,$AA,$AA,$A3,$00
      byte $00,$00,$00,$00,$00,$00,$03,$33,$33,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$02,$22,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$0C,$CC,$C0,$00,$00,$08,$88
      byte $80,$00,$00,$00,$08,$8C,$CC,$88,$00,$00,$00,$03,$3A,$AA,$33,$00
      byte $00,$00,$00,$00,$00,$00,$03,$33,$33,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$88,$88,$80,$00,$00,$00,$00,$33,$AA,$30,$00
      byte $00,$00,$00,$00,$00,$00,$03,$33,$30,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$33,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$33,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$0F,$00,$00,$00,$00,$00,$00,$0F,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$0F,$00,$00,$00,$00,$00,$00,$F0,$F0,$00,$00,$00
      byte $00,$0F,$00,$00,$00,$00,$0F,$FF,$00,$00,$0F,$00,$00,$00,$00,$00
      byte $00,$00,$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$0F,$00,$00,$00,$00,$00,$0F,$00,$0F,$00,$00,$00
      byte $00,$0F,$00,$00,$00,$00,$F0,$00,$00,$00,$0F,$00,$00,$00,$00,$00
      byte $00,$00,$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$0F,$00,$00,$00,$00,$00,$0F,$00,$0F,$00,$00,$00
      byte $00,$0F,$00,$00,$00,$00,$F0,$00,$00,$00,$0F,$00,$00,$00,$00,$00
      byte $00,$00,$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$0F,$FF,$00,$F0,$0F,$00,$0F,$00,$0F,$0F,$FF,$00
      byte $0F,$FF,$0F,$00,$F0,$00,$F0,$00,$00,$FF,$0F,$FF,$00,$0F,$F0,$0F
      byte $FF,$00,$F0,$0F,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$0F,$00,$F0,$F0,$0F,$00,$0F,$FF,$FF,$0F,$00,$F0
      byte $F0,$0F,$0F,$00,$F0,$00,$0F,$00,$0F,$00,$0F,$00,$F0,$F0,$0F,$0F
      byte $00,$F0,$F0,$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$0F,$00,$F0,$F0,$0F,$00,$0F,$00,$0F,$0F,$00,$F0
      byte $F0,$0F,$0F,$00,$F0,$00,$00,$F0,$0F,$00,$0F,$00,$F0,$FF,$FF,$0F
      byte $00,$F0,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$0F,$00,$F0,$F0,$0F,$00,$0F,$00,$0F,$0F,$00,$F0
      byte $F0,$0F,$0F,$00,$F0,$00,$00,$0F,$0F,$00,$0F,$00,$F0,$F0,$00,$0F
      byte $00,$F0,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$0F,$00,$F0,$F0,$0F,$00,$0F,$00,$0F,$0F,$00,$F0
      byte $F0,$0F,$0F,$00,$F0,$00,$00,$0F,$0F,$00,$0F,$00,$F0,$F0,$00,$0F
      byte $00,$F0,$F0,$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$0F,$FF,$00,$0F,$FF,$00,$0F,$00,$0F,$0F,$00,$F0
      byte $0F,$FF,$00,$FF,$F0,$00,$FF,$F0,$00,$FF,$0F,$00,$F0,$0F,$FF,$0F
      byte $00,$F0,$F0,$0F,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$F0,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$0F,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$03
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$F0,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$0F,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$33,$03
      byte $30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$FF,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$0F,$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$33,$33
      byte $30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$33,$33
      byte $30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$33,$03,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$33
      byte $00,$00,$30,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$03,$03,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$33,$33,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$30
      byte $00,$00,$33,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$33,$03,$30,$00,$00,$00,$00,$00,$00,$00
      byte $00,$33,$33,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$33,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$33,$33,$30,$00,$00,$00,$00,$00,$00,$00
      byte $00,$03,$33,$00,$00,$30,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$03,$33,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$33,$33,$30,$00,$00,$00,$00,$00,$00,$00
      byte $00,$03,$30,$00,$00,$33,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$03,$33,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$03,$33,$00,$00,$30,$30,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$33,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$03,$33,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$03,$30,$00,$00,$33,$30,$00,$00,$00,$00
      byte $00,$00,$00,$00,$03,$33,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$33,$33,$00,$00,$00,$00
      byte $00,$00,$00,$00,$03,$33,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$33,$33,$00,$00,$00,$00
      byte $00,$00,$00,$00,$03,$33,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$33,$33,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$03,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$33,$30,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$33,$03,$30,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$33,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$33,$33,$30,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$33,$33,$30,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$33,$00,$00
      byte $30,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$30,$00,$00
      byte $33,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $33,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03
      byte $33,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03
      byte $33,$33,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$0E,$E0,$E0,$00,$00,$00,$00,$EE,$E0,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$03
      byte $33,$30,$00,$00,$00,$00,$00,$00,$00,$0E,$0E,$00,$00,$00,$0E,$E0
      byte $00,$00,$00,$00,$00,$0E,$00,$0E,$00,$00,$00,$EE,$00,$00,$00,$00
      byte $00,$E0,$00,$00,$00,$00,$00,$00,$00,$E0,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $33,$00,$00,$00,$00,$00,$00,$00,$00,$E0,$0E,$0E,$E0,$00,$0E,$0E
      byte $0E,$E0,$E0,$E0,$00,$0E,$00,$00,$00,$00,$00,$E0,$E0,$EE,$E0,$EE
      byte $00,$E0,$00,$E0,$EE,$0E,$E0,$00,$0E,$00,$EE,$E0,$EE,$E0,$EE,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$E0,$0E,$0E,$00,$00,$0E,$0E
      byte $0E,$00,$E0,$E0,$00,$0E,$00,$0E,$0E,$E0,$00,$EE,$00,$EE,$E0,$E0
      byte $00,$E0,$00,$E0,$E0,$0E,$00,$00,$E0,$00,$E0,$E0,$E0,$E0,$EE,$E0
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$E0,$0E,$0E,$00,$00,$0E,$0E
      byte $0E,$00,$EE,$E0,$00,$0E,$00,$0E,$0E,$0E,$00,$E0,$E0,$E0,$00,$E0
      byte $00,$E0,$00,$E0,$E0,$0E,$00,$00,$E0,$00,$E0,$E0,$E0,$E0,$EE,$E0
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$0E,$0E,$0E,$00,$00,$0E,$E0
      byte $0E,$00,$EE,$E0,$00,$0E,$EE,$0E,$0E,$0E,$00,$E0,$E0,$EE,$E0,$EE
      byte $00,$0E,$E0,$E0,$E0,$0E,$E0,$00,$EE,$E0,$EE,$E0,$EE,$E0,$EE,$E0
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$0E,$E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$0E,$E0,$E0,$E0,$E0,$00,$E0,$E0
      byte $00,$00,$00,$E0,$00,$00,$0E,$E0,$00,$00,$E0,$00,$0E,$E0,$00,$00
      byte $E0,$00,$E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$0E,$00,$00,$E0,$E0,$00,$E0,$E0
      byte $EE,$00,$00,$E0,$E0,$00,$E0,$00,$00,$00,$E0,$00,$0E,$0E,$00,$00
      byte $E0,$00,$E0,$00,$E0,$E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$0E,$E0,$E0,$E0,$E0,$00,$E0,$E0
      byte $E0,$E0,$0E,$EE,$0E,$00,$E0,$00,$E0,$E0,$EE,$00,$0E,$E0,$E0,$E0
      byte $EE,$00,$0E,$00,$E0,$E0,$00,$00,$EE,$0E,$E0,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$0E,$00,$E0,$E0,$E0,$00,$E0,$E0
      byte $E0,$E0,$E0,$EE,$0E,$00,$E0,$00,$E0,$E0,$E0,$00,$0E,$00,$E0,$E0
      byte $E0,$00,$00,$E0,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$0E,$00,$E0,$E0,$E0,$00,$0E,$E0
      byte $E0,$E0,$EE,$E0,$E0,$00,$0E,$E0,$EE,$E0,$0E,$00,$0E,$00,$0E,$E0
      byte $0E,$00,$EE,$00,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
      
' ----- space for Menu -----
      byte 0[8*x_pixels]
              
font3x7
  byte  $00,$00,$00     '32
  byte  $00,$DE,$DE
  byte  $0E,$00,$0E
  byte  $FE,$28,$FE
  byte  $48,$D6,$24
  byte  $62,$18,$46
  byte  $6C,$92,$EC
  byte  $0E,$00,$0E     ''
  byte  $00,$7C,$82
  byte  $00,$82,$7C
  byte  $54,$38,$54
  byte  $10,$7C,$10
  byte  $00,$80,$60
  byte  $10,$10,$10
  byte  $00,$C0,$C0
  byte  $C0,$30,$0C
  byte  $7C,$82,$7C     '0
  byte  $04,$FE,$00
  byte  $E2,$92,$8C
  byte  $92,$92,$6C
  byte  $3E,$20,$F8
  byte  $9E,$92,$62
  byte  $7C,$92,$62
  byte  $02,$F2,$0E
  byte  $6C,$92,$6C
  byte  $8C,$92,$7C     '9
  byte  $00,$CC,$CC
  byte  $80,$EC,$6C     ';
  byte  $10,$28,$44
  byte  $28,$28,$28
  byte  $44,$28,$10
  byte  $02,$B2,$0C
  byte  $7C,$BA,$AA     '@
  byte  $FC,$12,$FC     'A
  byte  $FE,$92,$6C
  byte  $7C,$82,$82
  byte  $FE,$82,$7C
  byte  $FE,$92,$82
  byte  $FE,$12,$02
  byte  $7C,$82,$F2
  byte  $FE,$10,$FE
  byte  $82,$FE,$82
  byte  $60,$80,$7E
  byte  $FE,$38,$E6
  byte  $FE,$80,$80
  byte  $FE,$1C,$FE     'M
  byte  $FE,$02,$FC
  byte  $7C,$82,$7C
  byte  $FE,$12,$0C
  byte  $7C,$C2,$BC
  byte  $FE,$12,$EC
  byte  $8C,$92,$62
  byte  $02,$FE,$02
  byte  $7E,$80,$FE
  byte  $3E,$C0,$3E
  byte  $FE,$F0,$FE     'W
  byte  $EE,$10,$EE
  byte  $9E,$60,$1E
  byte  $E2,$9A,$86     'Z
  byte  $FE,$82,$82
  byte  $0C,$30,$C0
  byte  $82,$82,$FE
  byte  $0C,$02,$0C     '^
  byte  $80,$80,$80     '_

  byte  $3F,$2A,$3E,$2A,$3E,$00  'menu 96..107
  byte  $08,$04,$08,$30,$40,$20
  byte  $04,$04,$08,$08,$10,$10
  byte  $7C,$44,$44,$44,$44,$7C
  byte  $18,$24,$42,$42,$24,$18
  byte  $0C,$12,$72,$12,$0C,$00
  byte  $30,$48,$46,$48,$30,$00
  byte  $38,$30,$28,$04,$04,$38
  byte  $54,$00,$44,$00,$54,$00
  byte  $0E,$0A,$3A,$2E,$28,$38
  byte  $E2,$A6,$AE,$A6,$E2,$00
  byte  $E8,$AC,$AE,$AC,$E8,$00
              